## libr3 1.3.4

=== CMakeLists.txt ===
# cmake file examples
# https://code.google.com/p/opencv-feature-tracker/source/browse/CMakeLists.txt?r=f804b03e704147e65183c19a50f57abedb22f45c


# TODO:
# cmake clean... orz
# http://stackoverflow.com/questions/9680420/looking-for-a-cmake-clean-command-to-clear-up-cmake-output


cmake_minimum_required(VERSION 2.8)
project(r3)

SET(CMAKE_MODULE_PATH
    ${PROJECT_SOURCE_DIR}/cmake
    ${CMAKE_MODULE_PATH}
    )

include_directories(. ${PROJECT_SOURCE_DIR}/include ${PROJECT_SOURCE_DIR}/src ${PROJECT_SOURCE_DIR}/3rdparty /opt/local/include)
# include_directories(. ${PROJECT_SOURCE_DIR}/include ${PROJECT_SOURCE_DIR}/src ${PROJECT_SOURCE_DIR}/3rdparty ${PROJECT_SOURCE_DIR})

link_directories(${LINK_DIRECTORIES} /opt/local/lib)
find_package(PCRE REQUIRED)
# find_package(Judy REQUIRED)

# set(LIBS ${LIBS} ${PCRE_LIBRARIES} ${Judy_LIBRARIES} r3)
set(LIBS ${LIBS} ${PCRE_LIBRARIES} r3)

# set (CMAKE_CXX_FLAGS "-std=c++0x -arch x86_64 -stdlib=libc++ -g3 -Wall -O0")
enable_testing()

add_subdirectory(3rdparty)
add_subdirectory(src)
add_subdirectory(tests)
# add_test(test_tree ${CMAKE_CURRENT_BINARY_DIR}/check_tree)

=== 3rdparty/CMakeLists.txt ===
include_directories("${PROJECT_SOURCE_DIR}/3rdparty ${PROJECT_SOURCE_DIR}")
set(lib3rdparty_SRCS zmalloc.c)
add_library(lib3rdparty STATIC ${lib3rdparty_SRCS})
# add_library(r3 SHARED ${libr3_SRCS})
# target_link_libraries(r3 cblas)
# install(FILES ${libswiftnav_HEADERS} DESTINATION include/libswiftnav)

=== src/CMakeLists.txt ===
include_directories("${PROJECT_SOURCE_DIR}/include ${PROJECT_SOURCE_DIR}/src ${PROJECT_SOURCE_DIR}/3rdparty ${PROJECT_SOURCE_DIR}")
# install(TARGETS swiftnav-static DESTINATION lib${LIB_SUFFIX})
find_package(PCRE REQUIRED)
set(libr3_SRCS node.c edge.c list.c slug.c str.c token.c match_entry.c)
set(LIBS ${LIBS} ${PCRE_LIBRARIES} r3)

add_library(r3 STATIC ${libr3_SRCS})
target_link_libraries(r3 lib3rdparty pcre)
# install(FILES ${libswiftnav_HEADERS} DESTINATION include/libswiftnav)

=== tests/CMakeLists.txt ===
# set(TEST_LIBS ${TEST_LIBS} ${CHECK_LIBRARIES} judy libr3)
# set(TEST_LIBS ${TEST_LIBS} ${CHECK_LIBRARIES} judy libr3)
include_directories("${PROJECT_SOURCE_DIR}/include ${PROJECT_SOURCE_DIR}/src ${PROJECT_SOURCE_DIR}")
find_package(Check REQUIRED)
find_package(PCRE REQUIRED)
# find_package(Judy REQUIRED)

if (NOT CHECK_FOUND)
    message(STATUS "Skipping unit tests, Check library not found!")
else (NOT CHECK_FOUND)
    set(TEST_LIBS ${LIBS} ${CHECK_LIBRARIES} ${PCRE_LIBRARIES} r3)

    include_directories(${CHECK_INCLUDE_DIRS})
    # include_directories("${PROJECT_SOURCE_DIR}/include/r2")
    add_executable(check_tree check_tree.c)
    target_link_libraries(check_tree ${TEST_LIBS})

    add_custom_command(
        TARGET check_tree POST_BUILD
        COMMENT "Running unit tests"
        COMMAND check_tree
    )
endif (NOT CHECK_FOUND)

## libr3 1.3.1

=== debian/changelog ===
libr3 (1.3.1-3) unstable; urgency=medium

  * Fix pcre_exec's return type.
    Thanks to Kan-Ru Chen (陳侃如) (Closes: #754698)

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Mon, 04 Aug 2014 01:32:19 +0800

libr3 (1.3.1-2) unstable; urgency=medium

  * Update Vcs-* fields
  * Let libr3-dev depend on libpcre3-dev

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Sun, 06 Jul 2014 19:31:16 +0800

libr3 (1.3.1-1) unstable; urgency=medium

  * Initial release (Closes: #748748)

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Thu, 12 Jun 2014 20:36:16 +0800

=== debian/control ===
Source: libr3
Priority: optional
Maintainer: ChangZhuo Chen (陳昌倬) <czchen@gmail.com>
Build-Depends:
 debhelper (>= 9),
 automake,
 autotools-dev,
 check,
 libpcre3-dev,
 libtool,
 pkg-config
Standards-Version: 3.9.5
Section: libs
Homepage: https://github.com/c9s/r3
Vcs-Git: git://github.com/czchen/debian-libr3
Vcs-Browser: https://github.com/czchen/debian-libr3
XS-Testsuite: autopkgtest

Package: libr3-dev
Section: libdevel
Architecture: any
Depends:
 ${misc:Depends},
 libr3-0 (= ${binary:Version}),
 libpcre3-dev
Description: High-performance URL router library (development files)
 R3 is an URL router library with high performance, thus, it's implemented in
 C.  It compiles your route paths into a prefix trie. By using the constructed
 prefix trie in the start-up time, you can dispatch routes with efficiency.
 .
 This package contains development files for libr3.

Package: libr3-0
Provides: libr3
Multi-Arch: same
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: High-performance URL router library
 R3 is an URL router library with high performance, thus, it's implemented in
 C.  It compiles your route paths into a prefix trie. By using the constructed
 prefix trie in the start-up time, you can dispatch routes with efficiency.

Package: libr3-dbg
Section: debug
Priority: extra
Multi-Arch: same
Architecture: any
Depends:
 ${misc:Depends},
 libr3-0 (= ${binary:Version})
Description: High-performance URL router library (debug symbols)
 R3 is an URL router library with high performance, thus, it's implemented in
 C.  It compiles your route paths into a prefix trie. By using the constructed
 prefix trie in the start-up time, you can dispatch routes with efficiency.
 .
 This package contains debug symbols for libr3.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

%:
	dh $@  --with autotools-dev

override_dh_auto_configure:
	./autogen.sh
	dh_auto_configure -- --disable-silent-rules --enable-check

override_dh_strip:
	dh_strip --dbg-package=libr3-dbg

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.md

## libr3 1.3.4

=== debian/changelog ===
libr3 (1.3.4-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standard-Version to 3.9.7.
  * Remove upstream applied patch.
  * Set hardening=+all.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 07 Feb 2016 23:27:57 +0800

libr3 (1.3.3-2) unstable; urgency=medium

  * Update maintainer email
  * Update Vcs-* fields
  * Update gbp.conf
  * Use Expat as license short name.
  * Remove dbg package in favor of dbgsym.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 03 Jan 2016 18:24:09 +0800

libr3 (1.3.3-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 3.9.6.
  * Fix license name.
  * Update Vcs-*.
  * Use Testsuite instead of XS-Testsuite.
  * Add local-options.
  * Update symbol control file.

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Sun, 23 Aug 2015 21:18:37 +0800

=== debian/control ===
Source: libr3
Priority: optional
Maintainer: ChangZhuo Chen (陳昌倬) <czchen@debian.org>
Build-Depends: debhelper (>= 9.20151219),
               automake,
               autotools-dev,
               check,
               libpcre3-dev,
               libtool,
               pkg-config
Standards-Version: 3.9.7
Section: libs
Homepage: https://github.com/c9s/r3
Vcs-Git: https://anonscm.debian.org/cgit/collab-maint/libr3.git -b debian/sid
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libr3.git/?h=debian/sid
Testsuite: autopkgtest

Package: libr3-dev
Section: libdevel
Architecture: any
Depends:
 ${misc:Depends},
 libr3-0 (= ${binary:Version}),
 libpcre3-dev
Description: High-performance URL router library (development files)
 R3 is an URL router library with high performance, thus, it's implemented in
 C.  It compiles your route paths into a prefix trie. By using the constructed
 prefix trie in the start-up time, you can dispatch routes with efficiency.
 .
 This package contains development files for libr3.

Package: libr3-0
Provides: libr3
Multi-Arch: same
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: High-performance URL router library
 R3 is an URL router library with high performance, thus, it's implemented in
 C.  It compiles your route paths into a prefix trie. By using the constructed
 prefix trie in the start-up time, you can dispatch routes with efficiency.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@  --with autotools-dev

override_dh_auto_configure:
	./autogen.sh
	dh_auto_configure -- --disable-silent-rules --enable-check

override_dh_strip:
	dh_strip --ddeb-migration='libr3-dbg (<< 1.3.3-2~)'

override_dh_installchangelogs:
	dh_installchangelogs CHANGES.md

=== debian/tests/control ===
tests: build
Depends: libr3-dev, build-essential, pkg-config

=== debian/watch ===
version=3
https://github.com/c9s/r3/releases .*/(\d\S*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)
